#!/usr/bin/env python3
"""
Cylinders on a square 2D lattice with Crystal2D and
Cauchy decay function. Lattice spacing 10 nm, cylinder
radius and height 5 nm.
"""
from math import pi
import bornagain as ba
from bornagain import ba_plot as bp, deg, nm


def get_sample():
    # Materials
    particle_color = (0.86, 0.24, 0.18)
    particle_mat = ba.RefractiveMaterial("Particle", particle_color, 6e-4, 2e-8)
    substrate_color = (0.28, 0.57, 0.82)
    substrate_mat = ba.RefractiveMaterial("Substrate", substrate_color, 6e-6, 2e-8)
    vacuum = ba.Vacuum()

    # Particles
    ff = ba.Cylinder(5 * nm, 5 * nm)
    particle = ba.Particle(particle_mat, ff)

    # Square lattice with Crystal2D and Cauchy decay
    lattice = ba.SquareLattice2D(10 * nm, 0)
    layout = ba.Crystal2D(particle, lattice)
    profile = ba.Profile2DCauchy(
        300 / (2 * pi) * nm, 100 / (2 * pi) * nm, 0)
    layout.setDecayFunction(profile)

    # Layers
    layer_1 = ba.Layer(vacuum)
    layer_1.deposit2D(layout)
    layer_2 = ba.Layer(substrate_mat)

    # Sample
    sample = ba.Sample()
    sample.addLayer(layer_1)
    sample.addLayer(layer_2)
    return sample


<%= include_partial("template/sim/gisas_standard_wide.py") -%>


<%= include_partial("template/main/runsim_unitaspect.py",
    "ba.showSample3D(sample, sample_size=300*nm, seed=0)") -%>
